:userdoc.
:docprof toc=123456.
:title.Harbour Reference Guide
.* HBDOC generated IPF Source File.
.* HBDOC Document Source Extractor, (c)1999-2000 Luiz Rafael Culik.
:h1 res=1.GT_ASCPOS()
:i1 id=GT_ASCPOS().GT_ASCPOS()
:p.GT_ASCPOS()
:p.:hp2.Return the ascii value of a specified character in a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_Ascpos(<cStr>, <nPos>) --> nAscVal
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.    - The string <nPos>  - The position in <cStr>     

:p.:hp2.Returns
:ehp2.
      :hp2. <nAscVal>:ehp2.   - The ascii value of substr(<cStr>, <nPos>, 1)    

:p.:hp2.Description
:ehp2.
     Return the ascii value of a specified character in a string  Equivalent (but much faster) to  asc(substr(cStr&comma. nPos&comma. 1)       

     NOTE&colon.  invalid parameters will return -1  nPos > len(cStr)   will return -2       

     This last behaviour is different to the Funcky function of the  same name.  I changed the behaviour because some of the strings  I process contain embedded NULs.     

:p.:hp2.Examples
:ehp2.

       ? gt_ascpos(&cdq.the cat sat on the mat&cdq.&comma. 3) // prints e
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=2.GT_ASCIISUM()
:i1 id=GT_ASCIISUM().GT_ASCIISUM()
:p.GT_ASCIISUM()
:p.:hp2.Sum the ascii values in a string.
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_AsciiSum(<cStr>) --> nSum
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.    - The string to sum    

:p.:hp2.Returns
:ehp2.
      :hp2. <nSum>:ehp2.      - The sum of all ascii values in <cStr>.    

:p.:hp2.Description
:ehp2.
     Sum the ascii value of every character in the passed string  and return the result.     
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=3.GT_ATDIFF()
:i1 id=GT_ATDIFF().GT_ATDIFF()
:p.GT_ATDIFF()
:p.:hp2.Return the position where two strings begin to differ
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_AtDiff(<cStr1>, <cStr2>) --> nPos
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr1>:ehp2.    - A character string to compare <cStr2>  - The string to compare with     

:p.:hp2.Returns
:ehp2.
      :hp2. <nPos>:ehp2.       - The position in <cStr2> where <cStr1> begins to differ    

:p.:hp2.Description
:ehp2.
     Return the position in <cStr2> where <cStr1> begins to differ.  If the strings differ in the first character GT_AtDiff() will  return 1.  If the two strings are identical (or identical upto  the last character in <cStr2>) the function will return 0.       

     NOTE&colon.  invalid parameters will return -1     

:p.:hp2.Examples
:ehp2.

      ? gt_atDiff(&cdq.the cat&cdq.&comma. &cdq.the rat&cdq.)          // prints 5
      ? gt_atDiff(&cdq.the cat&cdq.&comma. &cdq.the &cdq.)             // prints 0
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=4.GT_CHAREVEN()
:i1 id=GT_CHAREVEN().GT_CHAREVEN()
:p.GT_CHAREVEN()
:p.:hp2.Return a string of all the characters in even positions
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_CharEven(<cStr>) --> cRet
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.     - A character string to extract chars from    

:p.:hp2.Returns
:ehp2.
      :hp2. <cRet>:ehp2.       - A string of all the chars in even positions    

:p.:hp2.Description
:ehp2.
     Return a string consisting of all the characters in even  positions in <cStr1>.       

     NOTE&colon.  invalid parameters will return &cdq.&cdq.     

:p.:hp2.Examples
:ehp2.

      ? gt_CharEven(&cdq.abcdefghijklm&cdq.)             // prints &cdq.bdfhjl&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=5.GT_CHARMIX()
:i1 id=GT_CHARMIX().GT_CHARMIX()
:p.GT_CHARMIX()
:p.:hp2.Amalgamate two strings to form the return value
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_CharMix(<cStr1>, <cStr2>) --> cRet
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr1>:ehp2.    - A character string to mix <cStr2>  - A character string to mix with     

:p.:hp2.Returns
:ehp2.
      :hp2. <cRet>:ehp2.       - A string consisting of all the characters in <cStr1> mixed with all the characters in <cStr2>     

:p.:hp2.Description
:ehp2.
     Return a string consisting of all the characters in <cStr1>  mixed with the characters from <cStr2>.       

     NOTE&colon.  invalid parameters will return &cdq.&cdq.     

:p.:hp2.Examples
:ehp2.

      ? gt_CharMix(&cdq.abc&cdq.&comma. &cdq.123&cdq.)               // prints &cdq.a1b2c3&cdq.
      ? gt_CharMix(&cdq.abcde&cdq.&comma. &cdq.123&cdq.)             // prints &cdq.a1b2c3de&cdq.
      ? gt_CharMix(&cdq.abc&cdq.&comma. &cdq.12345&cdq.)             // prints &cdq.a1b2c345&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=6.GT_CHARODD()
:i1 id=GT_CHARODD().GT_CHARODD()
:p.GT_CHARODD()
:p.:hp2.Return a string of all the characters in odd positions
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_CharOdd(<cStr>) --> cRet
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.     - A character string to extract chars from    

:p.:hp2.Returns
:ehp2.
      :hp2. <cRet>:ehp2.       - A string of all the chars in odd positions    

:p.:hp2.Description
:ehp2.
     Return a string consisting of all the characters in odd  positions in <cStr1>.       

     NOTE&colon.  invalid parameters will return &cdq.&cdq.     

:p.:hp2.Examples
:ehp2.

      ? gt_CharOdd(&cdq.abcdefghijklm&cdq.)             // prints &cdq.acegikm&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=7.GT_CHRCOUNT()
:i1 id=GT_CHRCOUNT().GT_CHRCOUNT()
:p.GT_CHRCOUNT()
:p.:hp2.Count the number of times a character appears in a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_ChrCount(<cChr>, <cStr>) --> nFreq
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cChr>:ehp2.    - The character to find the frequence of <cStr>  - The string in which to find the character     

:p.:hp2.Returns
:ehp2.
      nFreq    - The number of times <cChr> occurs in <cStr>    

:p.:hp2.Description
:ehp2.
     GT_ChrCount() counts how many times a specified character  appears in a string.       

     NOTE&colon.  invalid parameters will return -1     

:p.:hp2.Examples
:ehp2.

      ? GT_ChrCount(&cdq.t&cdq.&comma. &cdq.the cat sat on the mat&cdq.)      // prints 4
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=8.GT_CHRFIRST()
:i1 id=GT_CHRFIRST().GT_CHRFIRST()
:p.GT_CHRFIRST()
:p.:hp2.Find which character occurs first in a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_ChrFirst(<cChars>, <cStr>) --> nAsc
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cChars>:ehp2.   - The set of characters to find <cStr>   - The input string     

:p.:hp2.Returns
:ehp2.
      :hp2. <nAsc>:ehp2.       - The ASCII value of the first character in <cChars> which appears first in <cStr>     

:p.:hp2.Description
:ehp2.
     Return the ascii value of a character in <cChars>  which appears first in <cStr>.     

:p.:hp2.Examples
:ehp2.

      ? chr(GT_ChrFirst(&cdq.sa &cdq.&comma. &cdq.This is a test&cdq.))  // prints &cdq.s&cdq.
      ? chr(GT_ChrFirst(&cdq.et&cdq.&comma.  &cdq.This is a test&cdq.))   // prints &cdq.t&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=9.GT_CHRTOTAL()
:i1 id=GT_CHRTOTAL().GT_CHRTOTAL()
:p.GT_CHRTOTAL()
:p.:hp2.Find number of times a set of characters appears in a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_ChrTotal(<cChrs>, <cStr>) --> nTotOcc
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cChrs>:ehp2.   - The set of characters <cStr>  - The string to search     

:p.:hp2.Returns
:ehp2.
      :hp2. <nTotOcc>:ehp2.   - The number of times the characters specified in <cChrs> appears in <cStr>     

:p.:hp2.Description
:ehp2.
     Returns the numnber of occurrences of characters belonging  to the set <cChrs> in the string <cStr>.  If no characters  in <cChrs> appears in <cStr> GT_ChrTotal() will return 0.       

     NOTE&colon.  invalid parameters will return -1     

:p.:hp2.Examples
:ehp2.

       local cStr1 &colon.= &cdq.the cat sat on the mat&cdq.

       ? GT_ChrTotal(&cdq.tae&cdq.&comma. cStr1)            // prints 10
       ? GT_ChrTotal(&cdq.zqw&cdq.&comma. cStr1)            // prints  0
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=10.GT_STRCOUNT()
:i1 id=GT_STRCOUNT().GT_STRCOUNT()
:p.GT_STRCOUNT()
:p.:hp2.Count the number of times a substring appears in a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrCount(<cChrs>, <cStr>) --> nFreq
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cChrs>:ehp2.   - The substring to find the frequence of <cStr>  - The string in which to find the character     

:p.:hp2.Returns
:ehp2.
      :hp2. <nFreq>:ehp2.     - The number of times <cChrs> occurs in <cStr>    

:p.:hp2.Description
:ehp2.
     GT_StrCount() counts how many times a specified substring  appears in a string.  If the substring does NOT appear in <cStr> this function  will return 0.  If the substring is a single character use GT_ChrCount() as  it will be faster.       

     NOTE&colon.  invalid parameters will return -1     

:p.:hp2.Examples
:ehp2.

      ? GT_StrCount(&cdq.the&cdq.&comma. &cdq.the cat sat on the mat&cdq.)      // prints 2
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=11.GT_STRCSPN()
:i1 id=GT_STRCSPN().GT_STRCSPN()
:p.GT_STRCSPN()
:p.:hp2.Return length of prefix in string of chars NOT in set.
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_strcspn(<cString>, <cSet>) --> nLength
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cString>:ehp2.   - The string to find the prefix in <cSet>    - The set of characters     

:p.:hp2.Returns
:ehp2.
      :hp2. <nLength>:ehp2.     - The length of a string upto a character in the set    

:p.:hp2.Description
:ehp2.
     Return the number of characters in the leading segment of a  string that consists solely of characters NOT in the set.     

:p.:hp2.Examples
:ehp2.

      ? GT_strcspn(&cdq.this is a test&cdq.&comma. &cdq.as &cdq.)      // prints 3
      ? GT_strcspn(&cdq.this is a test&cdq.&comma. &cdq.elnjpq&cdq.)   // prints 11
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=12.GT_STRDIFF()
:i1 id=GT_STRDIFF().GT_STRDIFF()
:p.GT_STRDIFF()
:p.:hp2.Return a string where it begins to differ from another
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrDiff(<cStr1>, <cStr2>) --> cRet
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr1>:ehp2.    - A character string to compare <cStr2>  - The string to compare with     

:p.:hp2.Returns
:ehp2.
      :hp2. <cRet>:ehp2.       - A string beginning at the position in <cStr2> where <cStr1> begins to differ from <cStr1>     

:p.:hp2.Description
:ehp2.
     Return a string beginning at the position in <cStr2> where  <cStr1> begins to differ from <cStr1>. If the two strings are  identical (or identical upto the last character in <cStr2>)  the function will return &cdq.&cdq..       

     NOTE&colon.  invalid parameters will return &cdq.&cdq.     

:p.:hp2.Examples
:ehp2.

      ? gt_strDiff(&cdq.the cat&cdq.&comma. &cdq.the rat&cdq.)          // prints &cdq.rat&cdq.
      ? gt_strDiff(&cdq.the cat&cdq.&comma. &cdq.the &cdq.)             // prints &cdq.&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=13.GT_STREXPAND()
:i1 id=GT_STREXPAND().GT_STREXPAND()
:p.GT_STREXPAND()
:p.:hp2.Insert fillers between characters in a passed string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrExpand(<cStr>, [<nNum>], [<cChar>]) --> cRet
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr1>:ehp2.    - A character string to insert chars into <nNum>   - The number of fill characters to insert (default 1)  <cChar>  - The fill chararacter (default space)     

:p.:hp2.Returns
:ehp2.
      :hp2. <cRet>:ehp2.       - The input string with fill characters inserted between every character in the original.     

:p.:hp2.Description
:ehp2.
     Inserts fill characters into a string.       

     NOTE&colon.  invalid parameters will return &cdq.&cdq.     

:p.:hp2.Examples
:ehp2.

      ? gt_strexpand(&cdq.abc&cdq.)                    // prints &cdq.a b c&cdq.
      ? gt_strexpand(&cdq.abc&cdq.&comma. 2)                 // prints &cdq.a  b  c&cdq.
      ? gt_strexpand(&cdq.abc&cdq.&comma. 2&comma. '')            // prints &cdq.abc&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=14.GT_STRLEFT()
:i1 id=GT_STRLEFT().GT_STRLEFT()
:p.GT_STRLEFT()
:p.:hp2.Find length of prefix of a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrLeft(<cStr>, <cChars>) --> nLen
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.     - The input string <cChars> - The set of characters to find     

:p.:hp2.Returns
:ehp2.
      nLen      - The length of the prefix found.    

:p.:hp2.Description
:ehp2.
     Return the length of the leading segment in the passed string  <cStr> that consists solely of the characters in the character  set <cChars>.       

     If no characters in the the search set are found&comma. the function  shall return 0     

:p.:hp2.Examples
:ehp2.

      ? GT_StrLeft(&cdq.this is a test&cdq.&comma. &cdq.hsit &cdq.)       // prints 8
      ? GT_StrLeft(&cdq.this is a test&cdq.&comma. &cdq.hit a&cdq.)       // prints 3
      ? GT_StrLeft(&cdq.this is a test&cdq.&comma. &cdq.zxy&cdq.)         // prints 0
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=15.GT_STRPBRK()
:i1 id=GT_STRPBRK().GT_STRPBRK()
:p.GT_STRPBRK()
:p.:hp2.Return string after 1st char from a set
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrpBrk(<cStr>, <cSet>) --> cString
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.     - The input string <cSet>   - The set of characters to find     

:p.:hp2.Returns
:ehp2.
      :hp2. <cString>:ehp2.    - The input string after the first occurance of any character from <cSet>     

:p.:hp2.Description
:ehp2.
     Return a string after the first occurance of any character from  the input set <cSet>.     

:p.:hp2.Examples
:ehp2.

      ? GT_Strpbrk(&cdq.This is a test&cdq.&comma. &cdq.sa &cdq.)  // prints &cdq.s is a test&cdq.
      ? GT_Strpbrk(&cdq.This is a test&cdq.&comma. &cdq.et&cdq.)   // prints &cdq.test&cdq.
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:h1 res=16.GT_STRRIGHT()
:i1 id=GT_STRRIGHT().GT_STRRIGHT()
:p.GT_STRRIGHT()
:p.:hp2.Find length of a suffix of a string
:ehp2.
:p.:hp2.Syntax
:ehp2.
:p.:hp2.GT_StrRight(<cStr>, <cChars>) --> nLen
:ehp2.
:p.:hp2.Arguments
:ehp2.
      :hp2. <cStr>:ehp2.     - The input string <cChars> - The set of characters to find     

:p.:hp2.Returns
:ehp2.
      :hp2. <nLen>:ehp2.       - The length of the prefix found.    

:p.:hp2.Description
:ehp2.
     Return the length of the trailing segment in the passed string  <cStr> that consists solely of the characters in the character  set <cChars>.       

     If no characters in the the search set are found&comma. the function  shall return 0     

:p.:hp2.Examples
:ehp2.

      ? GT_StrRight(&cdq.this is a test&cdq.&comma. &cdq.teas &cdq.)       // prints 8
      ? GT_StrRight(&cdq.this is a test&cdq.&comma. &cdq.tes h&cdq.)       // prints 5
      ? GT_StrRight(&cdq.this is a test&cdq.&comma. &cdq.zxy&cdq.)         // prints 0
:p.:hp2.Status
:ehp2.
   Ready

:p.:hp2.Files
:ehp2.
     Library is libgt     
:euserdoc.
